using System.Globalization;

namespace File_Folder_Helper.Helpers;

internal static class HelperCreateNoteFiles
{

    internal static void CreateNoteFiles(string argsZero)
    {
        string file;
        string directory;
        string weekOfYear;
        DateTime dateTime;
        DateTime nowDateTime = DateTime.Now;
        string lastDirectory = string.Empty;
        DateTime firstEmail = new(2019, 3, 8);
        Calendar calendar = new CultureInfo("en-US").Calendar;
        const string line = "*** *** *** *** *** *** *** *** ***";
        double totalDays = new TimeSpan(nowDateTime.AddDays(1000).Ticks - firstEmail.Ticks).TotalDays;
        int days = (int)Math.Ceiling(totalDays);
        for (int i = 0; i < days; i++)
        {
            dateTime = firstEmail.AddDays(i);
            weekOfYear = calendar.GetWeekOfYear(dateTime, CalendarWeekRule.FirstDay, DayOfWeek.Sunday).ToString("00");
            directory = Path.Combine(argsZero, nowDateTime.Ticks.ToString(), dateTime.ToString("yyyy"), $"Week_{weekOfYear}");
            if (!Directory.Exists(directory))
                _ = Directory.CreateDirectory(directory);
            file = string.Concat(Path.Combine(directory, $"{dateTime:yyyy-MM-dd}.txt"));
            if (File.Exists(file))
                continue;
            File.WriteAllLines(file, new string[] { dateTime.ToString("dddd"), line, line, line, "", "TODO:", line, line, "", "Notes:", line, line });
            if (directory != lastDirectory)
            {
                Directory.SetCreationTime(directory, dateTime);
                Directory.SetLastWriteTime(directory, dateTime);
            }
            lastDirectory = directory;
        }
    }

}